/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 */
#ifndef GENHASH_H_INCLUDED
#define GENHASH_H_INCLUDED

/**********************************************************************************
 * Type definitions.
 */

typedef int (*KEYHASHFUNC)(const void *key);
typedef int (*KEYCOMPAREFUNC)(const void *key1, const void *key2);
typedef int (*TABLEWALKFUNC)(void *user_data, const void *key, void *data);

typedef void *HASHTABLE;

/**********************************************************************************
 * Function prototypes.
 */

extern HASHTABLE ghash_create(KEYHASHFUNC hash, KEYCOMPAREFUNC cmp);
extern void ghash_destroy(HASHTABLE tbl);
extern void *ghash_get(HASHTABLE tbl, const void *key);
extern int ghash_put(HASHTABLE tbl, const void *key, void *value);
extern int ghash_remove(HASHTABLE tbl, const void *key);
extern int ghash_walk(HASHTABLE tbl, TABLEWALKFUNC func, void *user_data);

int str_hash_code(const char *s);

#endif  /* GENHASH_H_INCLUDED */

