/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 *
 *  static.c.in -- starts statically linked modules
 *
 *  The build evironment uses this file to generate static.c, which 
 *  calls init functions for the static modules
 *
 */

#include "jserver.h"

/*
 *  js_static -- starts the static components
 */
void js_static()
{
	/* configure adds init calls for static modules here */
     xdb_file(); mod_roster(); mod_register(); mod_agents(); mod_log(); mod_auth_sha1(); mod_auth(); mod_vcard(); mod_announce(); mod_admin(); mod_private(); mod_offline(); mod_presence(); mod_etherx();              
    
/* initialize services */    
#ifdef HAVE_SVC_IRC
    svc_irc();
#endif
#ifdef HAVE_SVC_HTTP
    svc_http();
#endif
#ifdef HAVE_SVC_TELNET
    svc_telnet();
#endif
    svc_client();
#ifdef HAVE_SVC_HELL
    svc_hell();
#endif
    mod_dso();
    /* XXX add in all other default static ones */

}
