#include "svc_http.h"

/* create a new user account with this /register request */
void svc_http_register(hrq rq)
{
    jpacket p;

    /* setup reply body */
    rq->body = xmlnode_new_tag_pool(rq->p,"jabber");

    /* validate the request */
    if(xmlnode_get_attrib(rq->q,"user") == NULL || xmlnode_get_attrib(rq->q,"pass") == NULL)
    {
        xmlnode_put_attrib(rq->body,"error","No Username/Password");
        return;
    }

    /* jserver register */
    p = jpacket_new(jutil_iqnew(JPACKET__SET,NS_REGISTER));
    xmlnode_insert_cdata(xmlnode_insert_tag(p->iq, "username"),xmlnode_get_attrib(rq->q,"user"),-1);
    xmlnode_insert_cdata(xmlnode_insert_tag(p->iq, "password"),xmlnode_get_attrib(rq->q,"pass"),-1);
    xmlnode_insert_cdata(xmlnode_insert_tag(p->iq, "name"),xmlnode_get_attrib(rq->q,"name"),-1);
    xmlnode_insert_cdata(xmlnode_insert_tag(p->iq, "email"),xmlnode_get_attrib(rq->q,"email"),-1);
    log_debug(ZONE,"attempting to register with %s",xmlnode2str(p->x));

    js_service_prescreen(p);
    jpacket_reset(p);
    if(jpacket_subtype(p) == JPACKET__ERROR)
    { /* loozer */
        xmlnode_put_attrib(rq->body,"error",xmlnode_get_tag_data(p->x,"error"));
        xmlnode_free(p->x);
        return;
    }
    xmlnode_free(p->x);

    svc_http_session_reply(rq);
}

/* THE REST OF THE AGENTS HTTP INTERFACE MUST BE WRITTEN YET! /agents.*  */
