#include "svc_http.h"


/* collect cache items to process in bulk */
void svc_http_cache_send(hrq rq, jpcache cur)
{
    xmlnode curx, item;

    /* IQ's we convert */
    if(cur->p->type == JPACKET_IQ)
    {
        if(NSCHECK(cur->p->iq,NS_ROSTER))
        {
            /* convert roster items and insert into cache */
            for(curx = xmlnode_get_firstchild(cur->p->iq); curx != NULL; curx = xmlnode_get_nextsibling(curx))
            {
                if(xmlnode_get_type(curx) != NTYPE_TAG) continue;

                /* copy item and rename jid/s10n */
                item = xmlnode_insert_tag_node(rq->body,curx);
                xmlnode_hide_attrib(item,"jid");
                xmlnode_put_attrib(item,"from",xmlnode_get_attrib(curx,"jid"));
                xmlnode_hide_attrib(item,"subscription");
                xmlnode_put_attrib(item,"type",xmlnode_get_attrib(curx,"subscription"));
            }
        }
        /* drop the rest, support in the future! */
    }

    /* messages are just copied in and flagged, only removed on a second pass */
    if(cur->p->type == JPACKET_MESSAGE && cur->sent == 0)
    {
        cur->sent = 1;
        xmlnode_insert_tag_node(rq->body,cur->p->x);
    }

    /* presence just get's copied in */
    if(cur->p->type == JPACKET_PRESENCE || cur->p->type == JPACKET_S10N)
        xmlnode_insert_tag_node(rq->body,cur->p->x);

    /* unlink from the cache */
    cur->prev->next = cur->next;
    cur->next->prev = cur->prev;

    /* free the jpacket */
    xmlnode_free(cur->p->x);
}

void svc_http_cache(hs s, jpacket p)
{
    jpcache jp;

    jp = pmalloc(p->p, sizeof(_jpcache));
    jp->sent = 0;
    jp->p = p;

    /* insert into cache ring */
    jp->next = s->cache->next;
    s->cache->next->prev = jp;
    jp->prev = s->cache;
    s->cache->next = jp;

}
