#include "svc_http.h"

void svc_http_client(hrq rq)
{
    jpcache cur;

    log_debug(ZONE,"/client request with %s",xmlnode2str(rq->q));

    /* check for signoff */
    if(xmlnode_get_attrib(rq->q,"exit") != NULL)
    {
        js_session_end(rq->s->s, xmlnode_get_attrib(rq->q,"exit"));
        svc_http_session_reply(rq);
        return;
    }

    /* check for real-time request */
    if(strcmp(rq->ext,"hrt") == 0)
    { /* TBD */
        return svc_http_hrt(rq);
    }

    /* everything else is a request for any cached packets */
    for(cur = rq->s->cache->next; cur != rq->s->cache; cur = cur->next)
        svc_http_cache_send(rq,cur);

    svc_http_session_reply(rq);
}

