#include "svc_http.h"

void svc_http_hrt_cleanup(void *arg)
{
    hrq rq = (hrq)arg;
    hrq cur;

    log_debug(ZONE,"hrt thread %X closed, cleaning up",rq);

    /* session may have exited */
    if(rq->s == NULL) return;

    /* unlink from the RT chain */

    if(rq->s->rt == rq)
    {
        rq->s->rt = rq->next;
        return;
    }

    for(cur = rq->s->rt; cur != NULL; cur = cur->next)
        if(cur->next == rq)
            cur->next = rq->next;
}

void svc_http_hrt(hrq rq)
{
    jpcache cur;
    /*
        spool s;
        char pix[] = {
            0x47, 0x49, 0x46, 0x38, 0x37, 0x61, 0x01, 0x00,
            0x01, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
            0xFF, 0xFF, 0xFF};
    */

    log_debug(ZONE,"hrt starting %X",rq);

    /* cleanup if this thread dies */
    pool_cleanup(rq->p, svc_http_hrt_cleanup, (void *)rq);

    /* write the header and gif */
    tstream_write(rq->t,"HTTP/1.0 200 OK\r\nServer: jabber/svc_http\r\nConnection: close\r\nExpires: Fri, 10 Oct 1997 10:10:10 GMT\r\nPragma: no-cache\r\nCache-control: private\r\nContent-type: image/gif\r\n\r\n",-1);

    /* if there's already data waiting, respond */
    for(cur = rq->s->cache->next; cur != rq->s->cache; cur = cur->next)
        if(cur->sent == 0)
            return tstream_close(rq->t);

    /* associate w/ the session */
    rq->next = rq->s->rt;
    rq->s->rt = rq;
}

