#include "svc_http.h"

/* HTTP interface for presence
 * setting (GET/POST)
 *   /presence?sid&show&status
 * getting (GET) sid is optional, checks pub w/o
 *   /presence/uid.js?sid
 *   /presence/uid.xml?sid
 *   /presence/uid?sid
 */

void svc_http_roster(hrq rq)
{
    xmlnode cur, item;

    log_debug(ZONE,"/roster request %s",xmlnode2str(rq->q));

    for(cur = xmlnode_get_firstchild(js_xdb_get(rq->s->s->u,NS_ROSTER)); cur != NULL; cur = xmlnode_get_nextsibling(cur))
    {
        if(xmlnode_get_type(cur) != NTYPE_TAG) continue;

        /* copy item and rename jid/s10n */
        item = xmlnode_insert_tag_node(rq->body,cur);
        xmlnode_hide_attrib(item,"jid");
        xmlnode_put_attrib(item,"from",xmlnode_get_attrib(cur,"jid"));
        xmlnode_hide_attrib(item,"subscription");
        xmlnode_put_attrib(item,"type",xmlnode_get_attrib(cur,"subscription"));
    }

    svc_http_session_reply(rq);
}

